if (!nextplease) {
    var nextplease = {};
    
    nextplease.consoleService = Components.classes["@mozilla.org/consoleservice;1"].getService(Components.interfaces.nsIConsoleService);
    nextplease.prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("");
    
    nextplease.DEBUG = false;
    nextplease.DEBUG_DETAILED = false;
    // nextplease.DEBUG_FILE = false;
    nextplease.useSubmit = false;
    nextplease.useNumberShortcuts = true;
    nextplease.useContextMenu = true;
    nextplease.useSmartNext = false;
    nextplease.MAX_LINK_NUM = 1000;
    nextplease.MAX_GALLERY_GAP = 20;
    nextplease.MAX_IMAGE_CACHE = 500;
    nextplease.MAX_LINKS_TO_CHECK = 1000;
    
    nextplease.DefaultNextPhrases = ["Next", "next", "Next >", "next >", ">", "Next »", "next »", "»", "Next >>", "next >>", ">>", "≫", "MORE RESULTS",
                                        "Newer »", "Older topics »", "next page", "Go to the next photo in the stream", "次のページへ", "次ページ"];
    nextplease.DefaultPrevPhrases = ["Previous", "previous", "Prev", "prev", "< Previous", "< previous",
                                        "PREVIOUS RESULTS", "< Prev", "< prev", "<", "« Prev", "« prev", "«", "≪", "<< Prev", "<< prev", "<<",
                                        "« Older", "« Newer topics", "previous page", "Go to the previous photo in the stream", "前のページへ", "前ページ"];
    nextplease.DefaultFirstPhrases = ["First", "first", "< First", "< first", "first page", "« first", "« First"];
    nextplease.DefaultLastPhrases = ["Last", "last", "Last >", "last >", "last page", "last »", "Last »"];
    
    nextplease.DefaultNextImages = ["http://g-images.amazon.com/images/G/01/search-browse/button-more-results.gif"];
    nextplease.DefaultPrevImages = ["http://g-images.amazon.com/images/G/01/search-browse/button-previous.gif"];
    nextplease.DefaultFirstImages = [];
    nextplease.DefaultLastImages = [];
    
    nextplease.imageLocationMap = {};
    nextplease.imageLocationArray = [];
    
    // changed «chevrons» to \\xab and \\xbb - v1.31
    nextplease.DefaultNextRegEx  = "^next(\\s+\\d+)?(\\s+\\w+)?\\s*((>?>?)|\\xbb)\\s*\$";
    nextplease.DefaultPrevRegEx  = "^((<?<?)|\\xab)\\s*((prev(ious)?(\\s+\\d+)?(\\s+\\w+)?)|back)\\s*\$";
    nextplease.DefaultFirstRegEx = "^((<?<?)|\\xab)\\s*(first(\\s+\\d+)?(\\s+\\w+)?)\\s*$";
    nextplease.DefaultLastRegEx  = "^last(\\s+\\d+)?(\\s+\\w+)?\\s*((>?>?)|\\xbb)\\s*$";
    
    //    var nextplease.DefaultNextRegEx  = "^next(\\s+\\d+)?(\\s+\\w+)?\\s*((>?>?)|�|\\xbb)\\s*\$";
    //    var nextplease.DefaultPrevRegEx  = "^((<?<?)|�|\\xab)\\s*((prev(ious)?(\\s+\\d+)?(\\s+\\w+)?)|back)\\s*\$";
    //    var nextplease.DefaultFirstRegEx = "^((<?<?)|�|\\xab)\\s*(first(\\s+\\d+)?(\\s+\\w+)?)\\s*$";
    //    var nextplease.DefaultLastRegEx  = "^last(\\s+\\d+)?(\\s+\\w+)?\\s*((>?>?)|�|\\xbb)\\s*$";
    
    //    var OldDefaultGalleryRegEx  = ".*?(\\d+)[^/]*?\\.(?:jpg|gif|bmp|png)$";
    nextplease.DefaultGalleryRegEx  = "(.*(?:[^\\d]|^))(\\d+)([^/]*?\\.(?:jpg|gif|bmp|png))$";
    
    nextplease.NEXT_SEARCH_TYPE = 1;
    nextplease.PREV_SEARCH_TYPE = 2;
    nextplease.FIRST_SEARCH_TYPE = 3;
    nextplease.LAST_SEARCH_TYPE = 4;
    
    // Strip leading and trailing whitespace from
    // the passed in string and return it.
    nextplease.Trim = function (str) {
        return str.replace(/^\s*|\s*$/g, "");
    };
    
    nextplease.SetUnicharPref = function (aPrefName, aPrefValue) {
        // this.logDetail("setting " + aPrefName + " to " + aPrefValue);
        if (this.prefs) {
            try {
                var str = Components.classes["@mozilla.org/supports-string;1"].createInstance(Components.interfaces.nsISupportsString);
                str.data = aPrefValue;
                this.prefs.setComplexValue(aPrefName, Components.interfaces.nsISupportsString, str);
            }
            catch(e) {
                this.log("error while setting " + aPrefName + " to " + aPrefValue);
            }
        }
        else {
            this.log("error while setting " + aPrefName + " to " + aPrefValue + "; nextplease.prefs is not defined");
        }
    };
    
    nextplease.GetUnicharPref = function (aPrefName) {
        // this.logDetail("getting " + aPrefName);
        if (this.prefs) {
            try {
                return this.prefs.getComplexValue(aPrefName, Components.interfaces.nsISupportsString).data;
            }
            catch(e) {
                this.log("error while getting " + aPrefName);
            }
        }
        else {
            this.log("error while getting " + aPrefName + "; nextplease.prefs is not defined");
        }
        return "";
    };

    nextplease.log = function (message) {
        if (this.DEBUG) {
            this.consoleService.logStringMessage("NextPlease: " + message);
            //if (this.DEBUG_FILE && this._outputStream) {
            //    this._outputStream.write(message, message.length);
            //}
        }
    };
    
    nextplease.logDetail = function (message) {
        if (this.DEBUG_DETAILED) {
            this.consoleService.logStringMessage("NextPlease: " + message);
            //if (this.DEBUG_FILE && this._outputStream) {
            //    this._outputStream.write(message, message.length);
            //}
        }
    };

    // Initialize the lookup table for keycode to keyname
    nextplease.initializeKeyCodeToStringMap = function () {
        var map = {};
        map[KeyEvent.DOM_VK_LEFT] = "VK_LEFT";
        map[KeyEvent.DOM_VK_RIGHT] = "VK_RIGHT";
        map[KeyEvent.DOM_VK_UP] = "VK_UP";
        map[KeyEvent.DOM_VK_DOWN] = "VK_DOWN";
        map[KeyEvent.DOM_VK_PAGE_UP] = "VK_PAGE_UP";
        map[KeyEvent.DOM_VK_PAGE_DOWN] = "VK_PAGE_DOWN";
        map[KeyEvent.DOM_VK_HOME] = "VK_HOME";
        map[KeyEvent.DOM_VK_END] = "VK_END";
        map[KeyEvent.DOM_VK_F1] = "VK_F1";
        map[KeyEvent.DOM_VK_F2] = "VK_F2";
        map[KeyEvent.DOM_VK_F3] = "VK_F3";
        map[KeyEvent.DOM_VK_F4] = "VK_F4";
        map[KeyEvent.DOM_VK_F5] = "VK_F5";
        map[KeyEvent.DOM_VK_F6] = "VK_F6";
        map[KeyEvent.DOM_VK_F7] = "VK_F7";
        map[KeyEvent.DOM_VK_F8] = "VK_F8";
        map[KeyEvent.DOM_VK_F9] = "VK_F9";
        map[KeyEvent.DOM_VK_F10] = "VK_F10";
        map[KeyEvent.DOM_VK_F11] = "VK_F11";
        map[KeyEvent.DOM_VK_F12] = "VK_F12";
        return map;
    };

    nextplease.KeyCodeToNameMap = nextplease.initializeKeyCodeToStringMap();
}
